# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['InstanceArgs', 'Instance']

@pulumi.input_type
class InstanceArgs:
    def __init__(__self__, *,
                 image: pulumi.Input[str],
                 region: pulumi.Input[str],
                 type: pulumi.Input[str],
                 disk_size: Optional[pulumi.Input[int]] = None,
                 floating_ip_id: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input['InstanceMetadataArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 placement_option: Optional[pulumi.Input[str]] = None,
                 reservation_id: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_key_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 timeouts: Optional[pulumi.Input['InstanceTimeoutsArgs']] = None,
                 volume_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a Instance resource.
        :param pulumi.Input[str] image: The source image id, image slug or snapshot id of the instance. The image version can also specified together with the
               image slug in this format `<image-slug>:<version>`. Learn more about images
               [here](https://developers.genesiscloud.com/images). - If the value of this attribute changes, the resource will be
               replaced.
        :param pulumi.Input[str] region: The region identifier. - If the value of this attribute changes, the resource will be replaced. - The value must be one
               of: ["EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        :param pulumi.Input[str] type: The instance type identifier. Learn more about instance types
               [here](https://developers.genesiscloud.com/instances#instance-types). - If the value of this attribute changes, the
               resource will be replaced.
        :param pulumi.Input[int] disk_size: The disk size of the instance in GB.
        :param pulumi.Input[str] floating_ip_id: The floating IP attached to the instance.
        :param pulumi.Input['InstanceMetadataArgs'] metadata: Option to provide metadata. Currently supported is `startup_script`.
        :param pulumi.Input[str] name: The human-readable name for the instance.
        :param pulumi.Input[str] password: The password to access the instance. Your password must have upper and lower chars, digits and length between 8-72.
               **Please Note**: Only one of `ssh_keys` or `password` can be provided. Password is less secure - we recommend you use an
               SSH key-pair. - If the value of this attribute changes, the resource will be replaced. - The string length must be at
               least 16.
        :param pulumi.Input[str] placement_option: The placement option identifier in which instances are physically located relative to each other within a zone. For
               example A or B. - If the value of this attribute changes, the resource will be replaced.
        :param pulumi.Input[str] reservation_id: The id of the reservation the instance is associated with.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: The security groups of the instance. If not provided will be set to the default security group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_key_ids: The ssh keys of the instance. - If the value of this attribute changes, the resource will be replaced.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] volume_ids: The volumes of the instance.
        """
        pulumi.set(__self__, "image", image)
        pulumi.set(__self__, "region", region)
        pulumi.set(__self__, "type", type)
        if disk_size is not None:
            pulumi.set(__self__, "disk_size", disk_size)
        if floating_ip_id is not None:
            pulumi.set(__self__, "floating_ip_id", floating_ip_id)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if placement_option is not None:
            pulumi.set(__self__, "placement_option", placement_option)
        if reservation_id is not None:
            pulumi.set(__self__, "reservation_id", reservation_id)
        if security_group_ids is not None:
            pulumi.set(__self__, "security_group_ids", security_group_ids)
        if ssh_key_ids is not None:
            pulumi.set(__self__, "ssh_key_ids", ssh_key_ids)
        if timeouts is not None:
            pulumi.set(__self__, "timeouts", timeouts)
        if volume_ids is not None:
            pulumi.set(__self__, "volume_ids", volume_ids)

    @property
    @pulumi.getter
    def image(self) -> pulumi.Input[str]:
        """
        The source image id, image slug or snapshot id of the instance. The image version can also specified together with the
        image slug in this format `<image-slug>:<version>`. Learn more about images
        [here](https://developers.genesiscloud.com/images). - If the value of this attribute changes, the resource will be
        replaced.
        """
        return pulumi.get(self, "image")

    @image.setter
    def image(self, value: pulumi.Input[str]):
        pulumi.set(self, "image", value)

    @property
    @pulumi.getter
    def region(self) -> pulumi.Input[str]:
        """
        The region identifier. - If the value of this attribute changes, the resource will be replaced. - The value must be one
        of: ["EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: pulumi.Input[str]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        The instance type identifier. Learn more about instance types
        [here](https://developers.genesiscloud.com/instances#instance-types). - If the value of this attribute changes, the
        resource will be replaced.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="diskSize")
    def disk_size(self) -> Optional[pulumi.Input[int]]:
        """
        The disk size of the instance in GB.
        """
        return pulumi.get(self, "disk_size")

    @disk_size.setter
    def disk_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "disk_size", value)

    @property
    @pulumi.getter(name="floatingIpId")
    def floating_ip_id(self) -> Optional[pulumi.Input[str]]:
        """
        The floating IP attached to the instance.
        """
        return pulumi.get(self, "floating_ip_id")

    @floating_ip_id.setter
    def floating_ip_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "floating_ip_id", value)

    @property
    @pulumi.getter
    def hostname(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[pulumi.Input['InstanceMetadataArgs']]:
        """
        Option to provide metadata. Currently supported is `startup_script`.
        """
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[pulumi.Input['InstanceMetadataArgs']]):
        pulumi.set(self, "metadata", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The human-readable name for the instance.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[str]]:
        """
        The password to access the instance. Your password must have upper and lower chars, digits and length between 8-72.
        **Please Note**: Only one of `ssh_keys` or `password` can be provided. Password is less secure - we recommend you use an
        SSH key-pair. - If the value of this attribute changes, the resource will be replaced. - The string length must be at
        least 16.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter(name="placementOption")
    def placement_option(self) -> Optional[pulumi.Input[str]]:
        """
        The placement option identifier in which instances are physically located relative to each other within a zone. For
        example A or B. - If the value of this attribute changes, the resource will be replaced.
        """
        return pulumi.get(self, "placement_option")

    @placement_option.setter
    def placement_option(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "placement_option", value)

    @property
    @pulumi.getter(name="reservationId")
    def reservation_id(self) -> Optional[pulumi.Input[str]]:
        """
        The id of the reservation the instance is associated with.
        """
        return pulumi.get(self, "reservation_id")

    @reservation_id.setter
    def reservation_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "reservation_id", value)

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The security groups of the instance. If not provided will be set to the default security group.
        """
        return pulumi.get(self, "security_group_ids")

    @security_group_ids.setter
    def security_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_group_ids", value)

    @property
    @pulumi.getter(name="sshKeyIds")
    def ssh_key_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The ssh keys of the instance. - If the value of this attribute changes, the resource will be replaced.
        """
        return pulumi.get(self, "ssh_key_ids")

    @ssh_key_ids.setter
    def ssh_key_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "ssh_key_ids", value)

    @property
    @pulumi.getter
    def timeouts(self) -> Optional[pulumi.Input['InstanceTimeoutsArgs']]:
        return pulumi.get(self, "timeouts")

    @timeouts.setter
    def timeouts(self, value: Optional[pulumi.Input['InstanceTimeoutsArgs']]):
        pulumi.set(self, "timeouts", value)

    @property
    @pulumi.getter(name="volumeIds")
    def volume_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The volumes of the instance.
        """
        return pulumi.get(self, "volume_ids")

    @volume_ids.setter
    def volume_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "volume_ids", value)


@pulumi.input_type
class _InstanceState:
    def __init__(__self__, *,
                 created_at: Optional[pulumi.Input[str]] = None,
                 disk_size: Optional[pulumi.Input[int]] = None,
                 dns_name: Optional[pulumi.Input[str]] = None,
                 floating_ip_id: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image: Optional[pulumi.Input[str]] = None,
                 image_id: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input['InstanceMetadataArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 placement_option: Optional[pulumi.Input[str]] = None,
                 private_ip: Optional[pulumi.Input[str]] = None,
                 public_ip: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 reservation_id: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_key_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 timeouts: Optional[pulumi.Input['InstanceTimeoutsArgs']] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 updated_at: Optional[pulumi.Input[str]] = None,
                 volume_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering Instance resources.
        :param pulumi.Input[str] created_at: The timestamp when this image was created in RFC 3339.
        :param pulumi.Input[int] disk_size: The disk size of the instance in GB.
        :param pulumi.Input[str] dns_name: The dns name of the instance.
        :param pulumi.Input[str] floating_ip_id: The floating IP attached to the instance.
        :param pulumi.Input[str] image: The source image id, image slug or snapshot id of the instance. The image version can also specified together with the
               image slug in this format `<image-slug>:<version>`. Learn more about images
               [here](https://developers.genesiscloud.com/images). - If the value of this attribute changes, the resource will be
               replaced.
        :param pulumi.Input[str] image_id: The resulting image ID of the instance.
        :param pulumi.Input['InstanceMetadataArgs'] metadata: Option to provide metadata. Currently supported is `startup_script`.
        :param pulumi.Input[str] name: The human-readable name for the instance.
        :param pulumi.Input[str] password: The password to access the instance. Your password must have upper and lower chars, digits and length between 8-72.
               **Please Note**: Only one of `ssh_keys` or `password` can be provided. Password is less secure - we recommend you use an
               SSH key-pair. - If the value of this attribute changes, the resource will be replaced. - The string length must be at
               least 16.
        :param pulumi.Input[str] placement_option: The placement option identifier in which instances are physically located relative to each other within a zone. For
               example A or B. - If the value of this attribute changes, the resource will be replaced.
        :param pulumi.Input[str] private_ip: The private IPv4 IP-Address (IPv4 address).
        :param pulumi.Input[str] public_ip: The public IPv4 IP-Address (IPv4 address).
        :param pulumi.Input[str] region: The region identifier. - If the value of this attribute changes, the resource will be replaced. - The value must be one
               of: ["EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        :param pulumi.Input[str] reservation_id: The id of the reservation the instance is associated with.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: The security groups of the instance. If not provided will be set to the default security group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_key_ids: The ssh keys of the instance. - If the value of this attribute changes, the resource will be replaced.
        :param pulumi.Input[str] status: The instance status.
        :param pulumi.Input[str] type: The instance type identifier. Learn more about instance types
               [here](https://developers.genesiscloud.com/instances#instance-types). - If the value of this attribute changes, the
               resource will be replaced.
        :param pulumi.Input[str] updated_at: The timestamp when this image was last updated in RFC 3339.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] volume_ids: The volumes of the instance.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if disk_size is not None:
            pulumi.set(__self__, "disk_size", disk_size)
        if dns_name is not None:
            pulumi.set(__self__, "dns_name", dns_name)
        if floating_ip_id is not None:
            pulumi.set(__self__, "floating_ip_id", floating_ip_id)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if image is not None:
            pulumi.set(__self__, "image", image)
        if image_id is not None:
            pulumi.set(__self__, "image_id", image_id)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if placement_option is not None:
            pulumi.set(__self__, "placement_option", placement_option)
        if private_ip is not None:
            pulumi.set(__self__, "private_ip", private_ip)
        if public_ip is not None:
            pulumi.set(__self__, "public_ip", public_ip)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if reservation_id is not None:
            pulumi.set(__self__, "reservation_id", reservation_id)
        if security_group_ids is not None:
            pulumi.set(__self__, "security_group_ids", security_group_ids)
        if ssh_key_ids is not None:
            pulumi.set(__self__, "ssh_key_ids", ssh_key_ids)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if timeouts is not None:
            pulumi.set(__self__, "timeouts", timeouts)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)
        if volume_ids is not None:
            pulumi.set(__self__, "volume_ids", volume_ids)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[str]]:
        """
        The timestamp when this image was created in RFC 3339.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter(name="diskSize")
    def disk_size(self) -> Optional[pulumi.Input[int]]:
        """
        The disk size of the instance in GB.
        """
        return pulumi.get(self, "disk_size")

    @disk_size.setter
    def disk_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "disk_size", value)

    @property
    @pulumi.getter(name="dnsName")
    def dns_name(self) -> Optional[pulumi.Input[str]]:
        """
        The dns name of the instance.
        """
        return pulumi.get(self, "dns_name")

    @dns_name.setter
    def dns_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dns_name", value)

    @property
    @pulumi.getter(name="floatingIpId")
    def floating_ip_id(self) -> Optional[pulumi.Input[str]]:
        """
        The floating IP attached to the instance.
        """
        return pulumi.get(self, "floating_ip_id")

    @floating_ip_id.setter
    def floating_ip_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "floating_ip_id", value)

    @property
    @pulumi.getter
    def hostname(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter
    def image(self) -> Optional[pulumi.Input[str]]:
        """
        The source image id, image slug or snapshot id of the instance. The image version can also specified together with the
        image slug in this format `<image-slug>:<version>`. Learn more about images
        [here](https://developers.genesiscloud.com/images). - If the value of this attribute changes, the resource will be
        replaced.
        """
        return pulumi.get(self, "image")

    @image.setter
    def image(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image", value)

    @property
    @pulumi.getter(name="imageId")
    def image_id(self) -> Optional[pulumi.Input[str]]:
        """
        The resulting image ID of the instance.
        """
        return pulumi.get(self, "image_id")

    @image_id.setter
    def image_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_id", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[pulumi.Input['InstanceMetadataArgs']]:
        """
        Option to provide metadata. Currently supported is `startup_script`.
        """
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[pulumi.Input['InstanceMetadataArgs']]):
        pulumi.set(self, "metadata", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The human-readable name for the instance.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[str]]:
        """
        The password to access the instance. Your password must have upper and lower chars, digits and length between 8-72.
        **Please Note**: Only one of `ssh_keys` or `password` can be provided. Password is less secure - we recommend you use an
        SSH key-pair. - If the value of this attribute changes, the resource will be replaced. - The string length must be at
        least 16.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter(name="placementOption")
    def placement_option(self) -> Optional[pulumi.Input[str]]:
        """
        The placement option identifier in which instances are physically located relative to each other within a zone. For
        example A or B. - If the value of this attribute changes, the resource will be replaced.
        """
        return pulumi.get(self, "placement_option")

    @placement_option.setter
    def placement_option(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "placement_option", value)

    @property
    @pulumi.getter(name="privateIp")
    def private_ip(self) -> Optional[pulumi.Input[str]]:
        """
        The private IPv4 IP-Address (IPv4 address).
        """
        return pulumi.get(self, "private_ip")

    @private_ip.setter
    def private_ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "private_ip", value)

    @property
    @pulumi.getter(name="publicIp")
    def public_ip(self) -> Optional[pulumi.Input[str]]:
        """
        The public IPv4 IP-Address (IPv4 address).
        """
        return pulumi.get(self, "public_ip")

    @public_ip.setter
    def public_ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "public_ip", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        The region identifier. - If the value of this attribute changes, the resource will be replaced. - The value must be one
        of: ["EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="reservationId")
    def reservation_id(self) -> Optional[pulumi.Input[str]]:
        """
        The id of the reservation the instance is associated with.
        """
        return pulumi.get(self, "reservation_id")

    @reservation_id.setter
    def reservation_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "reservation_id", value)

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The security groups of the instance. If not provided will be set to the default security group.
        """
        return pulumi.get(self, "security_group_ids")

    @security_group_ids.setter
    def security_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_group_ids", value)

    @property
    @pulumi.getter(name="sshKeyIds")
    def ssh_key_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The ssh keys of the instance. - If the value of this attribute changes, the resource will be replaced.
        """
        return pulumi.get(self, "ssh_key_ids")

    @ssh_key_ids.setter
    def ssh_key_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "ssh_key_ids", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        The instance status.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def timeouts(self) -> Optional[pulumi.Input['InstanceTimeoutsArgs']]:
        return pulumi.get(self, "timeouts")

    @timeouts.setter
    def timeouts(self, value: Optional[pulumi.Input['InstanceTimeoutsArgs']]):
        pulumi.set(self, "timeouts", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        The instance type identifier. Learn more about instance types
        [here](https://developers.genesiscloud.com/instances#instance-types). - If the value of this attribute changes, the
        resource will be replaced.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[pulumi.Input[str]]:
        """
        The timestamp when this image was last updated in RFC 3339.
        """
        return pulumi.get(self, "updated_at")

    @updated_at.setter
    def updated_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "updated_at", value)

    @property
    @pulumi.getter(name="volumeIds")
    def volume_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The volumes of the instance.
        """
        return pulumi.get(self, "volume_ids")

    @volume_ids.setter
    def volume_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "volume_ids", value)


class Instance(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 disk_size: Optional[pulumi.Input[int]] = None,
                 floating_ip_id: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input[Union['InstanceMetadataArgs', 'InstanceMetadataArgsDict']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 placement_option: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 reservation_id: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_key_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 timeouts: Optional[pulumi.Input[Union['InstanceTimeoutsArgs', 'InstanceTimeoutsArgsDict']]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 volume_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Instance resource

        ## Example Usage

        ```python
        import pulumi
        import pulumi_genesiscloud as genesiscloud

        example = genesiscloud.Instance("example",
            image="ubuntu:22.04",
            region="NORD-NO-KRS-1",
            ssh_key_ids=["my-ssh-key-id"],
            type="vcpu-2_memory-4g")
        ```

        ## Import

        ```sh
        $ pulumi import genesiscloud:index/instance:Instance example 18efeec8-94f0-4776-8ff2-5e9b49c74608
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] disk_size: The disk size of the instance in GB.
        :param pulumi.Input[str] floating_ip_id: The floating IP attached to the instance.
        :param pulumi.Input[str] image: The source image id, image slug or snapshot id of the instance. The image version can also specified together with the
               image slug in this format `<image-slug>:<version>`. Learn more about images
               [here](https://developers.genesiscloud.com/images). - If the value of this attribute changes, the resource will be
               replaced.
        :param pulumi.Input[Union['InstanceMetadataArgs', 'InstanceMetadataArgsDict']] metadata: Option to provide metadata. Currently supported is `startup_script`.
        :param pulumi.Input[str] name: The human-readable name for the instance.
        :param pulumi.Input[str] password: The password to access the instance. Your password must have upper and lower chars, digits and length between 8-72.
               **Please Note**: Only one of `ssh_keys` or `password` can be provided. Password is less secure - we recommend you use an
               SSH key-pair. - If the value of this attribute changes, the resource will be replaced. - The string length must be at
               least 16.
        :param pulumi.Input[str] placement_option: The placement option identifier in which instances are physically located relative to each other within a zone. For
               example A or B. - If the value of this attribute changes, the resource will be replaced.
        :param pulumi.Input[str] region: The region identifier. - If the value of this attribute changes, the resource will be replaced. - The value must be one
               of: ["EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        :param pulumi.Input[str] reservation_id: The id of the reservation the instance is associated with.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: The security groups of the instance. If not provided will be set to the default security group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_key_ids: The ssh keys of the instance. - If the value of this attribute changes, the resource will be replaced.
        :param pulumi.Input[str] type: The instance type identifier. Learn more about instance types
               [here](https://developers.genesiscloud.com/instances#instance-types). - If the value of this attribute changes, the
               resource will be replaced.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] volume_ids: The volumes of the instance.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InstanceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Instance resource

        ## Example Usage

        ```python
        import pulumi
        import pulumi_genesiscloud as genesiscloud

        example = genesiscloud.Instance("example",
            image="ubuntu:22.04",
            region="NORD-NO-KRS-1",
            ssh_key_ids=["my-ssh-key-id"],
            type="vcpu-2_memory-4g")
        ```

        ## Import

        ```sh
        $ pulumi import genesiscloud:index/instance:Instance example 18efeec8-94f0-4776-8ff2-5e9b49c74608
        ```

        :param str resource_name: The name of the resource.
        :param InstanceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InstanceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 disk_size: Optional[pulumi.Input[int]] = None,
                 floating_ip_id: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input[Union['InstanceMetadataArgs', 'InstanceMetadataArgsDict']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 placement_option: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 reservation_id: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_key_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 timeouts: Optional[pulumi.Input[Union['InstanceTimeoutsArgs', 'InstanceTimeoutsArgsDict']]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 volume_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InstanceArgs.__new__(InstanceArgs)

            __props__.__dict__["disk_size"] = disk_size
            __props__.__dict__["floating_ip_id"] = floating_ip_id
            __props__.__dict__["hostname"] = hostname
            if image is None and not opts.urn:
                raise TypeError("Missing required property 'image'")
            __props__.__dict__["image"] = image
            __props__.__dict__["metadata"] = metadata
            __props__.__dict__["name"] = name
            __props__.__dict__["password"] = None if password is None else pulumi.Output.secret(password)
            __props__.__dict__["placement_option"] = placement_option
            if region is None and not opts.urn:
                raise TypeError("Missing required property 'region'")
            __props__.__dict__["region"] = region
            __props__.__dict__["reservation_id"] = reservation_id
            __props__.__dict__["security_group_ids"] = security_group_ids
            __props__.__dict__["ssh_key_ids"] = ssh_key_ids
            __props__.__dict__["timeouts"] = timeouts
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
            __props__.__dict__["volume_ids"] = volume_ids
            __props__.__dict__["created_at"] = None
            __props__.__dict__["dns_name"] = None
            __props__.__dict__["image_id"] = None
            __props__.__dict__["private_ip"] = None
            __props__.__dict__["public_ip"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["updated_at"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["password"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(Instance, __self__).__init__(
            'genesiscloud:index/instance:Instance',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            created_at: Optional[pulumi.Input[str]] = None,
            disk_size: Optional[pulumi.Input[int]] = None,
            dns_name: Optional[pulumi.Input[str]] = None,
            floating_ip_id: Optional[pulumi.Input[str]] = None,
            hostname: Optional[pulumi.Input[str]] = None,
            image: Optional[pulumi.Input[str]] = None,
            image_id: Optional[pulumi.Input[str]] = None,
            metadata: Optional[pulumi.Input[Union['InstanceMetadataArgs', 'InstanceMetadataArgsDict']]] = None,
            name: Optional[pulumi.Input[str]] = None,
            password: Optional[pulumi.Input[str]] = None,
            placement_option: Optional[pulumi.Input[str]] = None,
            private_ip: Optional[pulumi.Input[str]] = None,
            public_ip: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None,
            reservation_id: Optional[pulumi.Input[str]] = None,
            security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            ssh_key_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            status: Optional[pulumi.Input[str]] = None,
            timeouts: Optional[pulumi.Input[Union['InstanceTimeoutsArgs', 'InstanceTimeoutsArgsDict']]] = None,
            type: Optional[pulumi.Input[str]] = None,
            updated_at: Optional[pulumi.Input[str]] = None,
            volume_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'Instance':
        """
        Get an existing Instance resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] created_at: The timestamp when this image was created in RFC 3339.
        :param pulumi.Input[int] disk_size: The disk size of the instance in GB.
        :param pulumi.Input[str] dns_name: The dns name of the instance.
        :param pulumi.Input[str] floating_ip_id: The floating IP attached to the instance.
        :param pulumi.Input[str] image: The source image id, image slug or snapshot id of the instance. The image version can also specified together with the
               image slug in this format `<image-slug>:<version>`. Learn more about images
               [here](https://developers.genesiscloud.com/images). - If the value of this attribute changes, the resource will be
               replaced.
        :param pulumi.Input[str] image_id: The resulting image ID of the instance.
        :param pulumi.Input[Union['InstanceMetadataArgs', 'InstanceMetadataArgsDict']] metadata: Option to provide metadata. Currently supported is `startup_script`.
        :param pulumi.Input[str] name: The human-readable name for the instance.
        :param pulumi.Input[str] password: The password to access the instance. Your password must have upper and lower chars, digits and length between 8-72.
               **Please Note**: Only one of `ssh_keys` or `password` can be provided. Password is less secure - we recommend you use an
               SSH key-pair. - If the value of this attribute changes, the resource will be replaced. - The string length must be at
               least 16.
        :param pulumi.Input[str] placement_option: The placement option identifier in which instances are physically located relative to each other within a zone. For
               example A or B. - If the value of this attribute changes, the resource will be replaced.
        :param pulumi.Input[str] private_ip: The private IPv4 IP-Address (IPv4 address).
        :param pulumi.Input[str] public_ip: The public IPv4 IP-Address (IPv4 address).
        :param pulumi.Input[str] region: The region identifier. - If the value of this attribute changes, the resource will be replaced. - The value must be one
               of: ["EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        :param pulumi.Input[str] reservation_id: The id of the reservation the instance is associated with.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: The security groups of the instance. If not provided will be set to the default security group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_key_ids: The ssh keys of the instance. - If the value of this attribute changes, the resource will be replaced.
        :param pulumi.Input[str] status: The instance status.
        :param pulumi.Input[str] type: The instance type identifier. Learn more about instance types
               [here](https://developers.genesiscloud.com/instances#instance-types). - If the value of this attribute changes, the
               resource will be replaced.
        :param pulumi.Input[str] updated_at: The timestamp when this image was last updated in RFC 3339.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] volume_ids: The volumes of the instance.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InstanceState.__new__(_InstanceState)

        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["disk_size"] = disk_size
        __props__.__dict__["dns_name"] = dns_name
        __props__.__dict__["floating_ip_id"] = floating_ip_id
        __props__.__dict__["hostname"] = hostname
        __props__.__dict__["image"] = image
        __props__.__dict__["image_id"] = image_id
        __props__.__dict__["metadata"] = metadata
        __props__.__dict__["name"] = name
        __props__.__dict__["password"] = password
        __props__.__dict__["placement_option"] = placement_option
        __props__.__dict__["private_ip"] = private_ip
        __props__.__dict__["public_ip"] = public_ip
        __props__.__dict__["region"] = region
        __props__.__dict__["reservation_id"] = reservation_id
        __props__.__dict__["security_group_ids"] = security_group_ids
        __props__.__dict__["ssh_key_ids"] = ssh_key_ids
        __props__.__dict__["status"] = status
        __props__.__dict__["timeouts"] = timeouts
        __props__.__dict__["type"] = type
        __props__.__dict__["updated_at"] = updated_at
        __props__.__dict__["volume_ids"] = volume_ids
        return Instance(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[str]:
        """
        The timestamp when this image was created in RFC 3339.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="diskSize")
    def disk_size(self) -> pulumi.Output[int]:
        """
        The disk size of the instance in GB.
        """
        return pulumi.get(self, "disk_size")

    @property
    @pulumi.getter(name="dnsName")
    def dns_name(self) -> pulumi.Output[str]:
        """
        The dns name of the instance.
        """
        return pulumi.get(self, "dns_name")

    @property
    @pulumi.getter(name="floatingIpId")
    def floating_ip_id(self) -> pulumi.Output[Optional[str]]:
        """
        The floating IP attached to the instance.
        """
        return pulumi.get(self, "floating_ip_id")

    @property
    @pulumi.getter
    def hostname(self) -> pulumi.Output[str]:
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter
    def image(self) -> pulumi.Output[str]:
        """
        The source image id, image slug or snapshot id of the instance. The image version can also specified together with the
        image slug in this format `<image-slug>:<version>`. Learn more about images
        [here](https://developers.genesiscloud.com/images). - If the value of this attribute changes, the resource will be
        replaced.
        """
        return pulumi.get(self, "image")

    @property
    @pulumi.getter(name="imageId")
    def image_id(self) -> pulumi.Output[str]:
        """
        The resulting image ID of the instance.
        """
        return pulumi.get(self, "image_id")

    @property
    @pulumi.getter
    def metadata(self) -> pulumi.Output[Optional['outputs.InstanceMetadata']]:
        """
        Option to provide metadata. Currently supported is `startup_script`.
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The human-readable name for the instance.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def password(self) -> pulumi.Output[Optional[str]]:
        """
        The password to access the instance. Your password must have upper and lower chars, digits and length between 8-72.
        **Please Note**: Only one of `ssh_keys` or `password` can be provided. Password is less secure - we recommend you use an
        SSH key-pair. - If the value of this attribute changes, the resource will be replaced. - The string length must be at
        least 16.
        """
        return pulumi.get(self, "password")

    @property
    @pulumi.getter(name="placementOption")
    def placement_option(self) -> pulumi.Output[str]:
        """
        The placement option identifier in which instances are physically located relative to each other within a zone. For
        example A or B. - If the value of this attribute changes, the resource will be replaced.
        """
        return pulumi.get(self, "placement_option")

    @property
    @pulumi.getter(name="privateIp")
    def private_ip(self) -> pulumi.Output[str]:
        """
        The private IPv4 IP-Address (IPv4 address).
        """
        return pulumi.get(self, "private_ip")

    @property
    @pulumi.getter(name="publicIp")
    def public_ip(self) -> pulumi.Output[str]:
        """
        The public IPv4 IP-Address (IPv4 address).
        """
        return pulumi.get(self, "public_ip")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        The region identifier. - If the value of this attribute changes, the resource will be replaced. - The value must be one
        of: ["EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="reservationId")
    def reservation_id(self) -> pulumi.Output[Optional[str]]:
        """
        The id of the reservation the instance is associated with.
        """
        return pulumi.get(self, "reservation_id")

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> pulumi.Output[Sequence[str]]:
        """
        The security groups of the instance. If not provided will be set to the default security group.
        """
        return pulumi.get(self, "security_group_ids")

    @property
    @pulumi.getter(name="sshKeyIds")
    def ssh_key_ids(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        The ssh keys of the instance. - If the value of this attribute changes, the resource will be replaced.
        """
        return pulumi.get(self, "ssh_key_ids")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        The instance status.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def timeouts(self) -> pulumi.Output[Optional['outputs.InstanceTimeouts']]:
        return pulumi.get(self, "timeouts")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The instance type identifier. Learn more about instance types
        [here](https://developers.genesiscloud.com/instances#instance-types). - If the value of this attribute changes, the
        resource will be replaced.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> pulumi.Output[str]:
        """
        The timestamp when this image was last updated in RFC 3339.
        """
        return pulumi.get(self, "updated_at")

    @property
    @pulumi.getter(name="volumeIds")
    def volume_ids(self) -> pulumi.Output[Sequence[str]]:
        """
        The volumes of the instance.
        """
        return pulumi.get(self, "volume_ids")

